# Class PVector4L.Builder<T>

java.lang.Object
com.io7m.jtensors.core.parameterized.vectors.PVector4L.Builder<T>

Enclosing class:
  `PVector4L<T>`

public static final class PVector4L.Builder<T> extends Object
Builds instances of type `PVector4L`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `PVector4L<T>`
  `build()`
  Builds a new `PVector4L`.
  `final PVector4L.Builder<T>`
  `from(PVector4LType<T> instance)`
  Fill a builder with attribute values from the provided `com.io7m.jtensors.core.parameterized.vectors.PVector4LType` instance.
  `final PVector4L.Builder<T>`
  `from(PVectorReadable4LType<T> instance)`
  Fill a builder with attribute values from the provided `com.io7m.jtensors.core.parameterized.vectors.PVectorReadable4LType` instance.
  `final PVector4L.Builder<T>`
  `from(VectorReadable2LType instance)`
  Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.VectorReadable2LType` instance.
  `final PVector4L.Builder<T>`
  `from(VectorReadable3LType instance)`
  Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.VectorReadable3LType` instance.
  `final PVector4L.Builder<T>`
  `from(VectorReadable4LType instance)`
  Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.VectorReadable4LType` instance.
  `final PVector4L.Builder<T>`
  `setW(long w)`
  Initializes the value for the `w` attribute.
  `final PVector4L.Builder<T>`
  `setX(long x)`
  Initializes the value for the `x` attribute.
  `final PVector4L.Builder<T>`
  `setY(long y)`
  Initializes the value for the `y` attribute.
  `final PVector4L.Builder<T>`
  `setZ(long z)`
  Initializes the value for the `z` attribute.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final PVector4L.Builder<T> from(VectorReadable4LType instance)
    Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.VectorReadable4LType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### from

    public final PVector4L.Builder<T> from(PVector4LType<T> instance)
    Fill a builder with attribute values from the provided `com.io7m.jtensors.core.parameterized.vectors.PVector4LType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### from

    public final PVector4L.Builder<T> from(VectorReadable2LType instance)
    Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.VectorReadable2LType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### from

    public final PVector4L.Builder<T> from(PVectorReadable4LType<T> instance)
    Fill a builder with attribute values from the provided `com.io7m.jtensors.core.parameterized.vectors.PVectorReadable4LType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### from

    public final PVector4L.Builder<T> from(VectorReadable3LType instance)
    Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.VectorReadable3LType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setX

    public final PVector4L.Builder<T> setX(long x)
    Initializes the value for the `x` attribute.
    Parameters:
      `x` - The value for x
    Returns:
      `this` builder for use in a chained invocation

  - ### setY

    public final PVector4L.Builder<T> setY(long y)
    Initializes the value for the `y` attribute.
    Parameters:
      `y` - The value for y
    Returns:
      `this` builder for use in a chained invocation

  - ### setZ

    public final PVector4L.Builder<T> setZ(long z)
    Initializes the value for the `z` attribute.
    Parameters:
      `z` - The value for z
    Returns:
      `this` builder for use in a chained invocation

  - ### setW

    public final PVector4L.Builder<T> setW(long w)
    Initializes the value for the `w` attribute.
    Parameters:
      `w` - The value for w
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public PVector4L<T> build()
    Builds a new `PVector4L`.
    Returns:
      An immutable instance of PVector4L
    Throws:
      `IllegalStateException` - if any required attributes are missing